# coding: utf-8

"""
    VRt.Routing [RT]

    # Description  **VRt.Routing** is designed to find a route between locations and build time-distance matrices.  ## Features  * Getting the distance and time between two locations, including traffic jams * Finding a route between specified locations * Creating a time-distance matrix  ## Entity relationship diagram  ![erd](../uml/routing.svg) 

    The version of the OpenAPI document: 7.6.2491
    Contact: servicedesk@veeroute.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from vrt_lss_routing.models.route_statistics import RouteStatistics
from vrt_lss_routing.models.route_step import RouteStep
from typing import Optional, Set
from typing_extensions import Self

class RouteLeg(BaseModel):
    """
    The route leg between two locations.
    """ # noqa: E501
    steps: Annotated[List[RouteStep], Field(min_length=0, max_length=16)] = Field(description="Steps required to pass a route leg.")
    departure_name: Optional[Annotated[str, Field(min_length=0, strict=True, max_length=1024)]] = Field(default=None, description="Name of the departure point. Filled in if specified in the source data. ")
    destination_name: Optional[Annotated[str, Field(min_length=0, strict=True, max_length=1024)]] = Field(default=None, description="Name of the destination. Filled in if specified in the source data. ")
    statistics: RouteStatistics
    __properties: ClassVar[List[str]] = ["steps", "departure_name", "destination_name", "statistics"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RouteLeg from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in steps (list)
        _items = []
        if self.steps:
            for _item in self.steps:
                if _item:
                    _items.append(_item.to_dict())
            _dict['steps'] = _items
        # override the default output from pydantic by calling `to_dict()` of statistics
        if self.statistics:
            _dict['statistics'] = self.statistics.to_dict()
        # set to None if departure_name (nullable) is None
        # and model_fields_set contains the field
        if self.departure_name is None and "departure_name" in self.model_fields_set:
            _dict['departure_name'] = None

        # set to None if destination_name (nullable) is None
        # and model_fields_set contains the field
        if self.destination_name is None and "destination_name" in self.model_fields_set:
            _dict['destination_name'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RouteLeg from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "steps": [RouteStep.from_dict(_item) for _item in obj["steps"]] if obj.get("steps") is not None else None,
            "departure_name": obj.get("departure_name"),
            "destination_name": obj.get("destination_name"),
            "statistics": RouteStatistics.from_dict(obj["statistics"]) if obj.get("statistics") is not None else None
        })
        return _obj


